package org.garret.heap;

/**
 * Class representing relation between two classes
 */
public class Relation implements Comparable { 
    /**
     * Class of referenced objects
     */
    public final Class dst;

    /**
     * Class of object containing the reference
     */
    public final Class src;

    /**
     * Number of links between instances of these classes
     */
    public int         count;

    public boolean equals(Object obj) { 
        if (obj instanceof Relation) { 
            Relation rel = (Relation)obj;
            return dst == rel.dst && src == rel.src;
        }
        return false;
    }

    public int compareTo(Object o) { 
        return ((Relation)o).count - count;
    }

    public int hashCode() { 
        return src.hashCode() ^ dst.hashCode();
    }

    Relation(Class src, Class dst) {
        this.dst = dst;
        this.src = src;
    }
}
    